<template>
    <div v-if="author">
      <h2>{{ displayName }}</h2>
      <a :href="author.website" target="_blank" rel="noopener noreferrer">Website</a>
      <p>{{ author.bio }}</p>
      
      <!-- Display follower and following counts -->
      <div>
        <p>Followers: {{ author.user.followerCount || 0 }}</p>
        <p>Following: {{ author.user.followingCount || 0 }}</p>
      </div>
  
      <h3>Posts by {{ displayName }}</h3>
      <PostList :posts="author.postSet" :showAuthor="false" />
    </div>
</template>
  
<script>
import PostList from '@/components/blog/PostList'
import gql from 'graphql-tag';

export default {
name: 'TheAuthor',
components: {
    PostList,
},
data () {
    return {
    author: null,
    }
},
computed: {
    displayName () {
    return (
        this.author.user.firstName &&
        this.author.user.lastName &&
        `${this.author.user.firstName} ${this.author.user.lastName}`
    ) || `${this.author.user.username}`
    },
},
async created() {
    const user = await this.$apollo.query({
  query: gql`
        query ($username: String!) {
        authorByUsername(username: $username) {
            website
            bio
            user {
            username
            profile {
                followerCount
                followingCount
            }
            }
            postSet {
            title
            subtitle
            publishDate
            published
            metaDescription
            slug
            tags {
                name
            }
            }
        }
        }
  `,
  variables: {
    username: this.$route.params.username,
  },
});

this.author = user.data.authorByUsername;
},
}
</script>